"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CellDoesNotExistInGridError = void 0;
/**
 * An error that is thrown when the cell does not exist in the grid
 */
class CellDoesNotExistInGridError extends Error {
    type = CellDoesNotExistInGridError.name;
    /**
     * @param grid The grid
     * @param coordinate The coordinate of the not existing cell
     */
    constructor(grid, coordinate) {
        const { width, height } = grid;
        const { row, col } = coordinate;
        super(`Cell [row: ${row}, col: ${col}] does not exist in grid [width: ${width}, height: ${height}]`);
    }
}
exports.CellDoesNotExistInGridError = CellDoesNotExistInGridError;
