import type { Coordinate } from '../Coordinate';
import type { Grid } from '../Grid';
import type { Cell } from '../Cell';
/**
 * An error that is thrown when the cell does not exist in the grid
 */
export declare class CellDoesNotExistInGridError<Value, CellWithValue extends Cell<Value>> extends Error {
    readonly type: string;
    /**
     * @param grid The grid
     * @param coordinate The coordinate of the not existing cell
     */
    constructor(grid: Grid<Value, CellWithValue>, coordinate: Coordinate);
}
//# sourceMappingURL=CellDoesNotExistInGridError.d.ts.map